Mentions in JavaScript Rich Text Editor

The Mention feature, integrated with the JavaScript Rich Text Editor via the Mention component, enables users to tag or mention users or objects from a suggestion list. This functionality streamlines tagging by eliminating manual entry of names or identifiers, enhancing efficiency and accuracy.

Setup and configuration

Use the target property of the Mention control to specify the ID of the content editable div element within the Rich Text Editor. When setting the target, make sure to append the suffix _rte-edit-view to the ID. This allows you to enable the Mention functionality within the Rich Text Editor, so that users can mention or tag other users or objects from the suggested list while editing the text.

Using mentions

When users type the @ symbol followed by a character in the Rich Text Editor, a suggestion list appears. Users can then select an item from the list by:

  • Clicking on it
  • Typing the name of the item they want to tag

Customizing suggestion list

Minimum input length for Mention suggestions

You can control when the suggestion list appears by setting the minLength property in the Mention control. This property defines the minimum number of characters a user must type after the mention character (@) to trigger the search action. This is especially useful when working with large datasets, as it helps reduce unnecessary queries and improves performance.

By default, minLength is set to 0, which means the suggestion list appears immediately after the mention character is entered. However, you can increase this value to delay the search until the user has typed a specific number of characters.

In the following example, the minLength is set to 3, so the suggestion list will only appear once the user types three or more characters after the @ symbol.

window.emailData = [
    { Name: 'Selma Rose', EmailId: '[email protected]' },
    { Name: 'Maria', EmailId: '[email protected]' },
    { Name: 'Russo Kay', EmailId: '[email protected]' },
    { Name: 'Robert', EmailId: '[email protected]' },
    { Name: 'Camden Kate', EmailId: '[email protected]' },
]

var emailObj;
var editor = new ej.richtexteditor.RichTextEditor({
   placeholder: 'Type @ and tag the name',
});
editor.appendTo('#mention_integration');

// Initialize Mention control
emailObj = new ej.dropdowns.Mention({
    dataSource: emailData,
    fields: { text: 'Name' },
    target: '#mention_integration_rte-edit-view',
    minLength: 3,
});
emailObj.appendTo('#mentionEditor');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-richtexteditor/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="mentionEditor"></div>
            <div id="mention_integration">
                 <p>
                Hello
                <span contenteditable="false" class="e-mention-chip"
                  ><a href="mailto:[email protected]" title="[email protected]"
                    >Maria</a
                  ></span
                >
              </p>

              <p>
                Type <code>@</code> followed by at least
                <strong>3 characters</strong> to trigger the suggestion list.
              </p>
            </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customizing suggestion list count

You can control the number of items displayed in the Mention suggestion list using the suggestionCount property. This is particularly useful when working with large datasets, allowing you to limit the number of suggestions shown to the user.

By default, the suggestion list displays 25 items. You can customize this value to show fewer or more items based on your application’s needs.

In the example below, the suggestionCount is set to 5, so only 5 items will be displayed in the suggestion list when the user types the mention character (@).

window.emailData = [
    { Name: 'Selma Rose', EmailId: '[email protected]' },
    { Name: 'Maria', EmailId: '[email protected]' },
    { Name: 'Russo Kay', EmailId: '[email protected]' },
    { Name: 'Robert', EmailId: '[email protected]' },
    { Name: 'Camden Kate', EmailId: '[email protected]' },
    { Name: 'Sophia', EmailId: '[email protected]' },
    { Name: 'Margaret', EmailId: '[email protected]' },
    { Name: 'Ursula Ann', EmailId: '[email protected]' },
    { Name: 'Laura Grace', EmailId: '[email protected]' },
    { Name: 'Albert', EmailId: '[email protected]' },
    { Name: 'William', EmailId: '[email protected]' },
]

var emailObj;
var editor = new ej.richtexteditor.RichTextEditor({
   placeholder: 'Type @ and tag the name',
});
editor.appendTo('#mention_integration');

// Initialize Mention control
emailObj = new ej.dropdowns.Mention({
    dataSource: emailData,
    fields: { text: 'Name' },
    target: '#mention_integration_rte-edit-view',
    suggestionCount: 5,

});
emailObj.appendTo('#mentionEditor');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-richtexteditor/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="mentionEditor"></div>
            <div id="mention_integration">
                  <p>
                    Hello
                    <span contenteditable="false" class="e-mention-chip"
                      ><a href="mailto:[email protected]" title="[email protected]"
                        >Maria</a
                      ></span
                    >&#8203;
                  </p>
                  <p>The suggestion list displays only 5 items when typing the &#64; character, as the data source contains a large set of entries</p>
            </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customizing suggestion list using templates

Item template

You can customize how each item appears in the suggestion list using the itemTemplate property. This allows you to display additional details such as email, role, or profile image alongside the mention name.

Display template

Use the displayTemplate property to define how the selected mention appears in the editor content.

For example, by default, the mention chip renders as:

<span contenteditable="false" class="e-mention-chip">@Selma Rose</span>

Using the displayTemplate property, you can customize it to render as a clickable link:

<a href="mailto:[email protected]" title="[email protected]" aria-label="Email Selma Rose">@Selma Rose</a>

This allows you to create more interactive and informative mentions within the editor.

In the following sample, we configured the following properties:

  • itemTemplate - Used to display the customized appearance in suggestion list.
  • displayTemplate - Used to customize how the selected value appears in the editor content.
  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - The maximum number of items that will be displayed in the suggestion list.
/**
* Rich text Editor with Mentions
*/

window.emailData = [
  { Name: "Selma Rose", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/2.png", EmailId: "[email protected]" },
  { Name: "Maria", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/1.png", EmailId: "[email protected]" },
  { Name: "Russo Kay", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" },
  { Name: "Camden Kate", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/9.png", EmailId: "[email protected]" },
  { Name: "Robert", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
  { Name: "Garth", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/7.png", EmailId: "[email protected]" },
  { Name: "Andrew James", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic04.png", EmailId: "[email protected]" },
  { Name: "Olivia", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/5.png", EmailId: "[email protected]" },
  { Name: "Sophia", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/6.png", EmailId: "[email protected]" },
  { Name: "Margaret", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/3.png", EmailId: "[email protected]" },
  { Name: "Ursula Ann", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
  { Name: "Laura Grace", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/4.png", EmailId: "[email protected]" },
  { Name: "Albert", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic03.png", EmailId: "[email protected]" },
  { Name: "William", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" }
];

var emailObj;
var editor = new ej.richtexteditor.RichTextEditor({
   placeholder: 'Type @ and tag the name',
   actionBegin: function (args) {
       if (args.requestType === 'EnterAction' && emailObj.element.classList.contains('e-popup-open')) {
           args.cancel = true;
       }
   },
   value: `<p>Hello <span contenteditable="false" class="e-mention-chip"><a href="mailto:[email protected]" title="[email protected]">@Maria</a></span>,</p>
                <p>Welcome to the mention integration with rich text editor demo. Type <code>@</code> character and tag user from the suggestion list. </p>`
});
editor.appendTo('#mention_integration');

// Initialize Mention control
   emailObj = new ej.dropdowns.Mention({
   dataSource: emailData,
   fields: { text: 'Name' },
   suggestionCount: 8,
   displayTemplate: '<a href=mailto:${EmailId} title=${EmailId}>@${Name}</a>',
   itemTemplate: '<table><tr><td><div id="mention-TemplateList"><img class="mentionEmpImage" src="${EmployeeImage}" alt="employee" /><span class="e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom ${Status}"></span></div></td><td><span class="person">${Name}</span><span class="email">${EmailId}</span></td</tr></table>',
   popupWidth: '250px',
   popupHeight: '200px',
   target: '#mention_integration_rte-edit-view',
   allowSpaces: true
});
emailObj.appendTo('#mentionEditor');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Rich Text Editor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-richtexteditor/styles/tailwind3.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="mentionEditor"></div>
            <div id="mention_integration"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

View Sample

See also

Mentions in Vue Rich Text Editor

The Mention feature, integrated with the Rich Text Editor via the Mention component, enables users to tag or mention users or objects from a suggestion list. This functionality streamlines tagging by eliminating manual entry of names or identifiers, enhancing efficiency and accuracy.

Setup and configuration

Use the target property of the Mention component to specify the ID of the content editable div element within the Rich Text Editor. When setting the target, make sure to append the suffix _rte-edit-view to the ID. This allows you to enable the Mention functionality within the Rich Text Editor, so that users can mention or tag other users or objects from the suggested list while editing the text.

Using mentions

When users type the @ symbol followed by a character in the Rich Text Editor, a suggestion list appears. Users can then select an item from the list by:

  • Clicking on it
  • Typing the name of the item they want to tag

Customizing suggestion list

Minimum input length for Mention suggestions

You can control when the suggestion list appears by setting the minLength property in the Mention component. This property defines the minimum number of characters a user must type after the mention character (@) to trigger the search action. This is especially useful when working with large datasets, as it helps reduce unnecessary queries and improves performance.

By default, minLength is set to 0, which means the suggestion list appears immediately after the mention character is entered. However, you can increase this value to delay the search until the user has typed a specific number of characters.

In the following example, the minLength is set to 3, so the suggestion list will only appear once the user types three or more characters after the @ symbol.

<template>
  <div>
    <ejs-richtexteditor
      id="mention_integration"
      :value="rteValue"
      placeholder="Type @ and tag the name"
    ></ejs-richtexteditor>

    <ejs-mention
      ref="mentionObj"
      id="mentionEditor"
      target="#mention_integration_rte-edit-view"
      :minLength="3"
      :dataSource="data"
      :fields="fieldsData"
    ></ejs-mention>
  </div>
</template>

<script>
import { ref, provide } from 'vue';
import {
  RichTextEditorComponent as EjsRichtexteditor,
  HtmlEditor,
  Toolbar,
  Image,
  Link,
  QuickToolbar,
} from '@syncfusion/ej2-vue-richtexteditor';
import { MentionComponent as EjsMention } from '@syncfusion/ej2-vue-dropdowns';

provide('richtexteditor', [HtmlEditor, Toolbar, Image, Link, QuickToolbar]);

const mentionObj = ref(null);

const rteValue = `<p>Hello <span contenteditable="false" class="e-mention-chip">mailto:[email protected]@Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>@</code> character and tag user from the suggestion list.</p>`;

const data = [
  { Name: 'Selma Rose', EmailId: '[email protected]' },
  { Name: 'Maria', EmailId: '[email protected]' },
  { Name: 'Russo Kay', EmailId: '[email protected]' },
  { Name: 'Robert', EmailId: '[email protected]' },
  { Name: 'Camden Kate', EmailId: '[email protected]' },
];

const fieldsData = { text: 'Name' };
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";
</style>
<template>
    <div>
        <ejs-richtexteditor id="mention_integration" :value="rteValue" placeholder="Type @ and tag the name"></ejs-richtexteditor>
        <ejs-mention ref="mentionObj" id="mentionEditor" target="#mention_integration_rte-edit-view" :minLength="3" :dataSource="data" :fields="fieldsData"></ejs-mention>
    </div>
</template>

<script>
import { RichTextEditorComponent, Toolbar, Link, Image, QuickToolbar, HtmlEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { MentionComponent } from "@syncfusion/ej2-vue-dropdowns";

export default {
    name: "App",
    components: {
        "ejs-richtexteditor":RichTextEditorComponent,
        "ejs-mention":MentionComponent
    },
    data: function() {
        return {
            rteValue: `<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>`,
            data: [
                { Name: "Selma Rose",  EmailId: "[email protected]" },
                { Name: "Maria",   EmailId: "[email protected]" },
                { Name: "Russo Kay",  EmailId: "[email protected]" },
                { Name: "Camden Kate",  EmailId: "[email protected]" },
                { Name: "Robert",  EmailId: "[email protected]" },
                { Name: "Garth", EmailId: "[email protected]" },
            ],
            fieldsData: { text: 'Name' }
        };
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, QuickToolbar, HtmlEditor]
    },
};
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";

</style>

Customizing suggestion list count

You can control the number of items displayed in the Mention suggestion list using the suggestionCount property. This is particularly useful when working with large datasets, allowing you to limit the number of suggestions shown to the user.

By default, the suggestion list displays 25 items. You can customize this value to show fewer or more items based on your application’s needs.

In the example below, the suggestionCount is set to 5, so only 5 items will be displayed in the suggestion list when the user types the mention character (@)

<template>
  <div>
    <ejs-richtexteditor
      id="mention_integration"
      :value="rteValue"
      placeholder="Type @ and tag the name"
    ></ejs-richtexteditor>

    <ejs-mention
      ref="mentionObj"
      id="mentionEditor"
      target="#mention_integration_rte-edit-view"
      :suggestionCount="5"
      :dataSource="data"
      :fields="fieldsData"
    ></ejs-mention>
  </div>
</template>

<script>
import { ref, provide } from 'vue';
import {
  RichTextEditorComponent as EjsRichtexteditor,
  HtmlEditor,
  Toolbar,
  Image,
  Link,
  QuickToolbar,
} from '@syncfusion/ej2-vue-richtexteditor';
import { MentionComponent as EjsMention } from '@syncfusion/ej2-vue-dropdowns';

provide('richtexteditor', [HtmlEditor, Toolbar, Image, Link, QuickToolbar]);

const mentionObj = ref(null);

const rteValue = `<p>Hello <span contenteditable="false" class="e-mention-chip">mailto:[email protected]@Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>@</code> character and tag user from the suggestion list.</p>`;

const data = [
  { Name: 'Selma Rose', EmailId: '[email protected]' },
  { Name: 'Maria', EmailId: '[email protected]' },
  { Name: 'Russo Kay', EmailId: '[email protected]' },
  { Name: 'Robert', EmailId: '[email protected]' },
  { Name: 'Camden Kate', EmailId: '[email protected]' },
];

const fieldsData = { text: 'Name' };
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";
</style>
<template>
    <div>
        <ejs-richtexteditor id="mention_integration" :value="rteValue" placeholder="Type @ and tag the name"></ejs-richtexteditor>
        <ejs-mention ref="mentionObj" id="mentionEditor" target="#mention_integration_rte-edit-view" :suggestionCount="5" :dataSource="data" :fields="fieldsData"></ejs-mention>
    </div>
</template>

<script>
import { RichTextEditorComponent, Toolbar, Link, Image, QuickToolbar, HtmlEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { MentionComponent } from "@syncfusion/ej2-vue-dropdowns";

export default {
    name: "App",
    components: {
        "ejs-richtexteditor":RichTextEditorComponent,
        "ejs-mention":MentionComponent
    },
    data: function() {
        return {
            rteValue: `<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>`,
            data: [
                { Name: "Selma Rose",  EmailId: "[email protected]" },
                { Name: "Maria",   EmailId: "[email protected]" },
                { Name: "Russo Kay",  EmailId: "[email protected]" },
                { Name: "Camden Kate",  EmailId: "[email protected]" },
                { Name: "Robert",  EmailId: "[email protected]" },
                { Name: "Garth", EmailId: "[email protected]" },
            ],
            fieldsData: { text: 'Name' }
        };
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, QuickToolbar, HtmlEditor]
    },
};
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";

</style>

Customizing suggestion list using templates

Item template

You can customize how each item appears in the suggestion list using the itemTemplate property. This allows you to display additional details such as email, role, or profile image alongside the mention name.

Display template

Use the displayTemplate property to define how the selected mention appears in the editor content.

For example, by default, the mention chip renders as:

<span contenteditable="false" class="e-mention-chip">@Selma Rose</span>

Using the displayTemplate property, you can customize it to render as a clickable link:

<a href="mailto:[email protected]" title="[email protected]" aria-label="Email Selma Rose">@Selma Rose</a>

This allows you to create more interactive and informative mentions within the editor.

In the following sample, we configured the following properties:

  • itemTemplate - Used to display the customized appearance in suggestion list.
  • displayTemplate - Used to customize how the selected value appears in the editor content.
  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - The maximum number of items that will be displayed in the suggestion list.
<template>
    <div>
        <ejs-richtexteditor id="mention_integration" :value="rteValue" placeholder="Type @ and tag the name" :actionBegin="onActionBegin">
        </ejs-richtexteditor>
        <ejs-mention ref="mentionObj" id="mentionEditor" target="#mention_integration_rte-edit-view" :suggestionCount="8"
            :showMentionChar="false" :allowSpaces="true" :dataSource="data" :fields="fieldsData" popupWidth='250px'
            popupHeight='200px' :itemTemplate="'iTemplate'" :displayTemplate="'dTemplate'">
            <template v-slot:iTemplate="{ data }">
                <table>
                    <tr>
                        <td>
                            <div id="mention-TemplateList"><img class="mentionEmpImage" :src="data.EmployeeImage"
                                    alt="employee" /><span
                                    :class="'e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom' + data.Status"></span>
                            </div>
                        </td>
                        <td class="mentionNameList"><span class="person"></span><span
                                class="email"></span></td>
                    </tr>
                </table>
            </template>
            <template v-slot:dTemplate="{ data }">
                <a :href="'mailto:' + data.EmailId" :title="data.EmailId">@</a>
            </template>
        </ejs-mention>
    </div>
</template>

<script setup>
import { provide, ref } from 'vue';
import { RichTextEditorComponent as EjsRichtexteditor, Toolbar, Link, Image, QuickToolbar, HtmlEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { MentionComponent as EjsMention } from "@syncfusion/ej2-vue-dropdowns";

const rteValue= `<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>`;
const mentionObj = ref(null);
const data = [
    { Name: "Selma Rose", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/2.png", EmailId: "[email protected]" },
    { Name: "Maria", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/1.png", EmailId: "[email protected]" },
    { Name: "Russo Kay", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" },
    { Name: "Camden Kate", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/9.png", EmailId: "[email protected]" },
    { Name: "Robert", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
    { Name: "Garth", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/7.png", EmailId: "[email protected]" },
    { Name: "Andrew James", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic04.png", EmailId: "[email protected]" },
    { Name: "Olivia", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/5.png", EmailId: "[email protected]" },
    { Name: "Sophia", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/6.png", EmailId: "[email protected]" },
    { Name: "Margaret", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/3.png", EmailId: "[email protected]" },
    { Name: "Ursula Ann", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
    { Name: "Laura Grace", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/4.png", EmailId: "[email protected]" },
    { Name: "Albert", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic03.png", EmailId: "[email protected]" },
    { Name: "William", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" }
];
const fieldsData = { text: 'Name' };
const onActionBegin = (args) => {
    if (args.requestType === 'EnterAction' && mentionObj.value.ej2Instances.element.classList.contains('e-popup-open')) {
        args.cancel = true;
    }
};
provide('richtexteditor', [Toolbar, Link, Image, QuickToolbar, HtmlEditor]);
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";

#mention-TemplateList {
    position: relative;
    display: inline-block;
    padding: 2px;
}

.mentionNameList .person,
.mentionNameList.email {
    display: block;
    line-height: 20px;
    text-indent: 5px;
}

.mentionNameList .person {
    font-size: 16px;
}

.mentionEmpImage {
    display: inline-block;
    width: 46px;
    height: 46px;
    padding: 3px;
    border-radius: 25px;
}

#mention-TemplateList .e-badge-success {
    left: 76%;
    bottom: 4px;
    top: auto;
}

#mention_integration_rte-edit-view_popup .e-dropdownbase .e-list-item {
    line-height: 8px;
}

#mention-TemplateList .e-badge-success {
    background-color: #4d841d;
    color: #fff;
}

#mention-TemplateList .e-badge-success.away {
    background-color: #fedd2d;
    color: #fff;
}

#mention-TemplateList .e-badge-success.busy {
    background-color: #de1a1a;
    color: #fff;
}

#mention-TemplateList .e-badge.e-badge-dot {
    height: 10px;
    width: 10px;
}

#mention_integration .e-mention-chip {
    cursor: pointer;
}</style>
<template>
    <div>
        <ejs-richtexteditor id="mention_integration" :value="rteValue placeholder="Type @ and tag the name" :actionBegin="onActionBegin"></ejs-richtexteditor>
        <ejs-mention ref="mentionObj" id="mentionEditor" target="#mention_integration_rte-edit-view" :suggestionCount="8" :showMentionChar="false" :allowSpaces="true" :dataSource="data" :fields="fieldsData" popupWidth='250px' popupHeight='200px' :itemTemplate="'iTemplate'" :displayTemplate="'dTemplate'">
            <template v-slot:iTemplate="{data}">
                <table><tr><td><div id="mention-TemplateList"><img class="mentionEmpImage" :src="data.EmployeeImage" alt="employee" /><span :class="'e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom'+ data.Status"></span></div></td><td class="mentionNameList"><span class="person"></span><span class="email"></span></td></tr></table>
            </template>
            <template v-slot:dTemplate="{data}">
                <a :href="'mailto:' + data.EmailId" :title="data.EmailId">@</a>
            </template>
        </ejs-mention>
    </div>
</template>

<script>
import { RichTextEditorComponent, Toolbar, Link, Image, QuickToolbar, HtmlEditor } from "@syncfusion/ej2-vue-richtexteditor";
import { MentionComponent } from "@syncfusion/ej2-vue-dropdowns";

export default {
    name: "App",
    components: {
        "ejs-richtexteditor":RichTextEditorComponent,
        "ejs-mention":MentionComponent
    },
    data: function() {
        return {
            rteValue: `<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>`,
            data: [
                { Name: "Selma Rose", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/2.png", EmailId: "[email protected]" },
                { Name: "Maria", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/1.png", EmailId: "[email protected]" },
                { Name: "Russo Kay", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" },
                { Name: "Camden Kate", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/9.png", EmailId: "[email protected]" },
                { Name: "Robert", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
                { Name: "Garth", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/7.png", EmailId: "[email protected]" },
                { Name: "Andrew James", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic04.png", EmailId: "[email protected]" },
                { Name: "Olivia", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/5.png", EmailId: "[email protected]" },
                { Name: "Sophia", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/6.png", EmailId: "[email protected]" },
                { Name: "Margaret", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/3.png", EmailId: "[email protected]" },
                { Name: "Ursula Ann", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
                { Name: "Laura Grace", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/4.png", EmailId: "[email protected]" },
                { Name: "Albert", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic03.png", EmailId: "[email protected]" },
                { Name: "William", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" }
            ],
            fieldsData: { text: 'Name' }
        };
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, QuickToolbar, HtmlEditor]
    },
    methods: {
       onActionBegin: function(args) {
            if (args.requestType === 'EnterAction' && this.$refs.mentionObj.ej2Instances.element.classList.contains('e-popup-open')) {
                args.cancel = true;
            }
        }
    }
};
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";

#mention-TemplateList {
        position: relative;
        display: inline-block;
        padding: 2px;
    }
    .mentionNameList .person, .mentionNameList.email {
        display: block;
        line-height: 20px;
        text-indent: 5px;
    }
    .mentionNameList .person {
        font-size: 16px;
    }
    .mentionEmpImage {
        display: inline-block;
        width: 46px;
        height: 46px;
        padding: 3px;
        border-radius: 25px;
    }
    #mention-TemplateList .e-badge-success {
        left: 76%;
        bottom: 4px;
        top: auto;
    }
    #mention_integration_rte-edit-view_popup .e-dropdownbase .e-list-item {
        line-height: 8px;
    }
    #mention-TemplateList .e-badge-success {
        background-color: #4d841d;
        color: #fff;
    }
    #mention-TemplateList .e-badge-success.away {
        background-color: #fedd2d;
        color: #fff;
    }
    #mention-TemplateList .e-badge-success.busy {
        background-color: #de1a1a;
        color: #fff;
    }
    #mention-TemplateList .e-badge.e-badge-dot {
        height: 10px;
        width: 10px;
    }
    #mention_integration .e-mention-chip{
        cursor: pointer;
    }
</style>

View Sample

See also

Mentions in Angular Rich Text Editor

The Mention feature, integrated with the Syncfusion Angular Rich Text Editor via the Mention component, enables users to tag or mention users or objects from a suggestion list. This functionality streamlines tagging by eliminating manual entry of names or identifiers, enhancing efficiency and accuracy.

Setup and configuration

Use the target property of the Mention component to specify the ID of the content editable div element within the Rich Text Editor. When setting the target, make sure to append the suffix _rte-edit-view to the ID. This allows you to enable the Mention functionality within the Rich Text Editor, so that users can mention or tag other users or objects from the suggested list while editing the text.

Using mentions

When users type the @ symbol followed by a character in the Rich Text Editor, a suggestion list appears. Users can then select an item from the list by:

  • Clicking on it.
  • Typing the name of the item they want to tag.

Customize the suggestion list

Set the minimum input length for Mention suggestions

You can control when the suggestion list appears by setting the minLength property in the Mention component. This property defines the minimum number of characters a user must type after the mention character (@) to trigger the search action. This is especially useful when working with large datasets, as it helps reduce unnecessary queries and improves performance.

By default, minLength is set to 0, which means the suggestion list appears immediately after the mention character is entered. However, you can increase this value to delay the search until the user has typed a specific number of characters.

In the following example, the minLength is set to 3, so the suggestion list will only appear once the user types three or more characters after the @ symbol.

import { MentionModule } from '@syncfusion/ej2-angular-dropdowns';
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorModule, ToolbarService, HtmlEditorService, ImageService, LinkService, QuickToolbarService, TableService, PasteCleanupService } from '@syncfusion/ej2-angular-richtexteditor';

@Component({
  imports: [RichTextEditorModule, MentionModule],
  standalone: true,
  selector: 'app-root',
  template: `
  <div>
    <ejs-richtexteditor
      id="mention_integration"
      placeholder="Type @ and tag the name"
    >
      <ng-template #valueTemplate>
        <p>
          Hello
          <span contenteditable="false" class="e-mention-chip"
            ><a href="mailto:[email protected]" title="[email protected]"
              >Maria</a
            ></span
          >&#8203;
        </p>
        <p>
          Type <code>&#64;</code> followed by at least
          <strong>3 characters</strong> to trigger the suggestion list.
        </p>
      </ng-template>
    </ejs-richtexteditor>
  </div>
  <div>
    <ejs-mention
    #mention
    [dataSource]="data"
    target="#mention_integration_rte-edit-view"
    [fields]="fieldsData"
    [minLength]="3"
  >
  </ejs-mention>
  </div>
`,
  providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, TableService, PasteCleanupService]
})

export class AppComponent {
  public data: { [key: string]: MentionModule }[] = [
      { Name: 'Selma Rose', EmailId: '[email protected]' },
      { Name: 'Maria', EmailId: '[email protected]' },
      { Name: 'Russo Kay', EmailId: '[email protected]' },
      { Name: 'Robert', EmailId: '[email protected]' },
      { Name: 'Camden Kate', EmailId: '[email protected]' },
  ];
  public fieldsData: { [key: string]: string } = { text: 'Name' };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize the suggestion list count

You can control the number of items displayed in the Mention suggestion list using the suggestionCount property. This is particularly useful when working with large datasets, letting you limit the number of suggestions shown to the user.

By default, the suggestion list displays 25 items. You can customize this value to show fewer or more items based on your application’s needs.

In the example below, the suggestionCount is set to 5, so only 5 items will be displayed in the suggestion list when the user types the mention character (@).

import { MentionModule } from '@syncfusion/ej2-angular-dropdowns';
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorModule, ToolbarService, HtmlEditorService, ImageService, LinkService, QuickToolbarService, TableService, PasteCleanupService } from '@syncfusion/ej2-angular-richtexteditor';

@Component({
  imports: [RichTextEditorModule, MentionModule],
  standalone: true,
  selector: 'app-root',
  template: `
  <div>
    <ejs-richtexteditor
      id="mention_integration"
      placeholder="Type @ and tag the name"
    >
      <ng-template #valueTemplate>
        <p>
          Hello
          <span contenteditable="false" class="e-mention-chip"
            ><a href="mailto:[email protected]" title="[email protected]"
              >Maria</a
            ></span
          >&#8203;
        </p>
        <p>
        The suggestion list displays only 5 items when typing the &#64; character, as the data source contains a large set of entries
        </p>
      </ng-template>
    </ejs-richtexteditor>
  </div>
  <div>
    <ejs-mention
    #mention
    [dataSource]="data"
    target="#mention_integration_rte-edit-view"
    [fields]="fieldsData"
    [suggestionCount]="5"
  >
  </ejs-mention>
  </div>
`,
  providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, TableService, PasteCleanupService]
})

export class AppComponent {
  public data: { [key: string]: MentionModule }[] = [
      { Name: 'Selma Rose', EmailId: '[email protected]' },
      { Name: 'Maria', EmailId: '[email protected]' },
      { Name: 'Russo Kay', EmailId: '[email protected]' },
      { Name: 'Robert', EmailId: '[email protected]' },
      { Name: 'Camden Kate', EmailId: '[email protected]' },
      { Name: 'Sophia', EmailId: '[email protected]' },
      { Name: 'Margaret', EmailId: '[email protected]' },
      { Name: 'Ursula Ann', EmailId: '[email protected]' },
      { Name: 'Laura Grace', EmailId: '[email protected]' },
      { Name: 'Albert', EmailId: '[email protected]' },
      { Name: 'William', EmailId: '[email protected]' },
  ];
  public fieldsData: { [key: string]: string } = { text: 'Name' };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize the suggestion list using templates

Item template

You can customize how each item appears in the suggestion list using the itemTemplate property. This lets you display additional details such as email, role, or profile image alongside the mention name.

Display template

Use the displayTemplate property to define how the selected mention appears in the editor content.

For example, by default, the mention chip renders as:

<span contenteditable="false" class="e-mention-chip">@Selma Rose</span>

Using the displayTemplate property, you can customize it to render as a clickable link:

<a href="mailto:[email protected]" title="[email protected]" aria-label="Email Selma Rose">@Selma Rose</a>

This allows you to create more interactive and informative mentions within the editor.

In the following sample, we configured the following properties:

  • itemTemplate - Used to display the customized appearance in suggestion list.
  • displayTemplate - Used to customize how the selected value appears in the editor content.
  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - The maximum number of items that will be displayed in the suggestion list.
import { MentionModule, Mention } from '@syncfusion/ej2-angular-dropdowns';
import { Component, ViewChild } from '@angular/core';
import { RichTextEditorModule, ActionBeginEventArgs, ToolbarSettingsModel, ToolbarService, HtmlEditorService, ImageService, LinkService, QuickToolbarService, TableService, PasteCleanupService } from '@syncfusion/ej2-angular-richtexteditor';

@Component({
  imports: [RichTextEditorModule, MentionModule],
  standalone: true,
  selector: 'app-root',
  template: `<ejs-richtexteditor id="mention_integration"  placeholder="Type @ and tag the name" (actionBegin)="onActionBegin($event)" [value]='value'>
</ejs-richtexteditor>
<ejs-mention #mention [dataSource]='data' target='#mention_integration_rte-edit-view' [fields]='fieldsData' [suggestionCount]="8" [showMentionChar]="false" [allowSpaces]="true"  
popupWidth='250px' popupHeight='200px'>
     <ng-template #itemTemplate let-data>
        <table>
            <tr>
              <td>
                <div id="mention-TemplateList"> 
                  <img class="mentionEmpImage" src="https://ej2.syncfusion.com/angular/demos/assets/rich-text-editor/images/.png" alt="employee" />
                  <span class="e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom "></span>
                </div>
                </td>
                <td class="mentionNameList">
                  <span class="person"></span>
                  <span class="email"></span>
                </td>
              </tr>
            </table>
    </ng-template>
    <ng-template #displayTemplate let-data>
        <a href="mailto:" title="">&#64;</a>
    </ng-template>
</ejs-mention>
`,
  providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, TableService, PasteCleanupService]
})

export class AppComponent {
  public value: string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
  @ViewChild('mention') mentionObj!: Mention;
  public toolbarSettings: ToolbarSettingsModel = {
    items: ['Bold', 'Italic', 'Underline', '|', 'Formats', 'Alignments', 'OrderedList',
      'UnorderedList', '|', 'CreateLink', 'Image', '|', 'SourceCode', '|', 'Undo', 'Redo'
    ]
  };
  public data: { [key: string]: MentionModule }[] = [
    { Name: "Selma Rose", Status: "active", Eimg: "2", EmailId: "[email protected]" },
    { Name: "Maria", Status: "active", Eimg: "1", EmailId: "[email protected]" },
    { Name: "Russo Kay", Status: "busy", Eimg: "8", EmailId: "[email protected]" },
    { Name: "Camden Kate", Status: "active", Eimg: "9", EmailId: "[email protected]" },
    { Name: "Robert", Status: "busy", Eimg: "dp", EmailId: "[email protected]" },
    { Name: "Garth", Status: "active", Eimg: "7", EmailId: "[email protected]" },
    { Name: "Andrew James", Status: "away", Eimg: "pic04", EmailId: "[email protected]" },
    { Name: "Olivia", Status: "busy", Eimg: "5", EmailId: "[email protected]" },
    { Name: "Sophia", Status: "away", Eimg: "6", EmailId: "[email protected]" },
    { Name: "Margaret", Status: "active", Eimg: "3", EmailId: "[email protected]" },
    { Name: "Ursula Ann", Status: "active", Eimg: "dp", EmailId: "[email protected]" },
    { Name: "Laura Grace", Status: "away", Eimg: "4", EmailId: "[email protected]" },
    { Name: "Albert", Status: "active", Eimg: "pic03", EmailId: "[email protected]" },
    { Name: "William", Status: "away", Eimg: "10", EmailId: "[email protected]" }
  ];
  public fieldsData: { [key: string]: string } = { text: 'Name' };

  onActionBegin(args: ActionBeginEventArgs) {
    if (args.requestType === 'EnterAction' && this.mentionObj.element.classList.contains('e-popup-open')) {
      args.cancel = true;
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

View Sample

See also

Mentions in React Rich Text Editor

The Mention feature, integrated with the Syncfusion React Rich Text Editor via the Mention component, enables users to tag or mention users or objects from a suggestion list. This functionality streamlines tagging by eliminating manual entry of names or identifiers, enhancing efficiency and accuracy.

Setup and configuration

Use the target property of the Mention component to specify the ID of the content editable div element within the Rich Text Editor. When setting the target, make sure to append the suffix _rte-edit-view to the ID. This allows you to enable the Mention functionality within the Rich Text Editor, so that users can mention or tag other users or objects from the suggested list while editing the text.

Using mentions

When users type the @ symbol followed by a character in the Rich Text Editor, a suggestion list appears. Users can then select an item from the list by:

  • Clicking on it
  • Typing the name of the item they want to tag

Customizing suggestion list

Minimum input length for Mention suggestions

You can control when the suggestion list appears by setting the minLength property in the Mention component. This property defines the minimum number of characters a user must type after the mention character (@) to trigger the search action. This is especially useful when working with large datasets, as it helps reduce unnecessary queries and improves performance.

By default, minLength is set to 0, which means the suggestion list appears immediately after the mention character is entered. However, you can increase this value to delay the search until the user has typed a specific number of characters.

In the following example, the minLength is set to 3, so the suggestion list will only appear once the user types three or more characters after the @ symbol.

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

class App extends React.Component {
    data = [
        { Name: 'Selma Rose', EmailId: '[email protected]' },
        { Name: 'Maria', EmailId: '[email protected]' },
        { Name: 'Russo Kay', EmailId: '[email protected]' },
        { Name: 'Robert', EmailId: '[email protected]' },
        { Name: 'Camden Kate', EmailId: '[email protected]' },
    ];
    fieldsData = { text: 'Name' };
  
    rteValue = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
    
    render() {
        return (<div className='control-pane'>
        <div className='control-section' id="rte">
          <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={this.rteValue} placeholder="Type @ and tag the name">
              <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
          </div>
        </div>

        <MentionComponent id="mentionEditor" minLength={3} target="#mention_integration_rte-edit-view" dataSource={this.data} fields={this.fieldsData}></MentionComponent>
      </div>);
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

class App extends React.Component<{},{}> {
  public mentionObj : MentionComponent;
  private data: { [key: string]: Object }[] = [
      { Name: 'Selma Rose', EmailId: '[email protected]' },
      { Name: 'Maria', EmailId: '[email protected]' },
      { Name: 'Russo Kay', EmailId: '[email protected]' },
      { Name: 'Robert', EmailId: '[email protected]' },
      { Name: 'Camden Kate', EmailId: '[email protected]' },
  ];
  private  fieldsData: { [key: string]: string }={ text: 'Name' };

  private rteValue:string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
    
  render() {
    return (
      <div className='control-pane'>
        <div className='control-section' id="rte">
          <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={this.rteValue} placeholder="Type @ and tag the name"  >
              <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]} />
            </RichTextEditorComponent>
          </div>
        </div>

        <MentionComponent ref={(scope) => { this.mentionObj = scope; }} id="mentionEditor" target="#mention_integration_rte-edit-view" dataSource={this.data} fields={this.fieldsData} minLength={3}></MentionComponent>
      </div>
    );
  }
}

export default App;

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

function App() {
    let rteValue = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
   
    let data = [
        { Name: 'Selma Rose', EmailId: '[email protected]' },
        { Name: 'Maria', EmailId: '[email protected]' },
        { Name: 'Russo Kay', EmailId: '[email protected]' },
        { Name: 'Robert', EmailId: '[email protected]' },
        { Name: 'Camden Kate', EmailId: '[email protected]' },
    ];
    let fieldsData = { text: 'Name' };
    return (<div className='control-pane'>
        <div className='control-section' id="rte">
        <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={rteValue} placeholder="Type @ and tag the name">
            <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
        </div>
        </div>
        <MentionComponent id="mentionEditor" minLength={3} target="#mention_integration_rte-edit-view" dataSource={data} fields={fieldsData}></MentionComponent>
    </div>);
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

function App() {
    let rteValue:string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
 
    let data: { [key: string]: Object }[] = [
        { Name: 'Selma Rose', EmailId: '[email protected]' },
        { Name: 'Maria', EmailId: '[email protected]' },
        { Name: 'Russo Kay', EmailId: '[email protected]' },
        { Name: 'Robert', EmailId: '[email protected]' },
        { Name: 'Camden Kate', EmailId: '[email protected]' },
    ];
    let  fieldsData: { [key: string]: string }={ text: 'Name' };

    return (
    <div className='control-pane'>
        <div className='control-section' id="rte">
        <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={rteValue} placeholder="Type @ and tag the name">
            <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
        </div>
        </div>
        <MentionComponent id="mentionEditor" minLength={3} target="#mention_integration_rte-edit-view" dataSource={data} fields={fieldsData}></MentionComponent>
    </div>
    );
}

export default App;

Customizing suggestion list count

You can control the number of items displayed in the Mention suggestion list using the suggestionCount property. This is particularly useful when working with large datasets, allowing you to limit the number of suggestions shown to the user.

By default, the suggestion list displays 25 items. You can customize this value to show fewer or more items based on your application’s needs.

In the example below, the suggestionCount is set to 5, so only 5 items will be displayed in the suggestion list when the user types the mention character (@).

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

class App extends React.Component {
    data = [
      { Name: 'Selma Rose', EmailId: '[email protected]' },
      { Name: 'Maria', EmailId: '[email protected]' },
      { Name: 'Russo Kay', EmailId: '[email protected]' },
      { Name: 'Robert', EmailId: '[email protected]' },
      { Name: 'Camden Kate', EmailId: '[email protected]' },
      { Name: 'Sophia', EmailId: '[email protected]' },
      { Name: 'Margaret', EmailId: '[email protected]' },
      { Name: 'Ursula Ann', EmailId: '[email protected]' },
      { Name: 'Laura Grace', EmailId: '[email protected]' },
      { Name: 'Albert', EmailId: '[email protected]' },
      { Name: 'William', EmailId: '[email protected]' },
    ];
    fieldsData = { text: 'Name' };
  
    rteValue = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
    
    render() {
        return (<div className='control-pane'>
        <div className='control-section' id="rte">
          <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={this.rteValue} placeholder="Type @ and tag the name">
              <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
          </div>
        </div>

        <MentionComponent id="mentionEditor" suggestionCount={5} target="#mention_integration_rte-edit-view" dataSource={this.data} fields={this.fieldsData}></MentionComponent>
      </div>);
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

class App extends React.Component<{},{}> {
  public mentionObj : MentionComponent;
  private data: { [key: string]: Object }[] = [
      { Name: 'Selma Rose', EmailId: '[email protected]' },
      { Name: 'Maria', EmailId: '[email protected]' },
      { Name: 'Russo Kay', EmailId: '[email protected]' },
      { Name: 'Robert', EmailId: '[email protected]' },
      { Name: 'Camden Kate', EmailId: '[email protected]' },
      { Name: 'Sophia', EmailId: '[email protected]' },
      { Name: 'Margaret', EmailId: '[email protected]' },
      { Name: 'Ursula Ann', EmailId: '[email protected]' },
      { Name: 'Laura Grace', EmailId: '[email protected]' },
      { Name: 'Albert', EmailId: '[email protected]' },
      { Name: 'William', EmailId: '[email protected]' },
  ];
  private  fieldsData: { [key: string]: string }={ text: 'Name' };

  private rteValue:string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
    
  render() {
    return (
      <div className='control-pane'>
        <div className='control-section' id="rte">
          <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={this.rteValue} placeholder="Type @ and tag the name"  >
              <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]} />
            </RichTextEditorComponent>
          </div>
        </div>

        <MentionComponent ref={(scope) => { this.mentionObj = scope; }} id="mentionEditor" target="#mention_integration_rte-edit-view" dataSource={this.data} fields={this.fieldsData} suggestionCount={5}></MentionComponent>
      </div>
    );
  }
}

export default App;

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

function App() {
    let rteValue = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
   
    let data = [
        { Name: 'Selma Rose', EmailId: '[email protected]' },
        { Name: 'Maria', EmailId: '[email protected]' },
        { Name: 'Russo Kay', EmailId: '[email protected]' },
        { Name: 'Robert', EmailId: '[email protected]' },
        { Name: 'Camden Kate', EmailId: '[email protected]' },
        { Name: 'Sophia', EmailId: '[email protected]' },
        { Name: 'Margaret', EmailId: '[email protected]' },
        { Name: 'Ursula Ann', EmailId: '[email protected]' },
        { Name: 'Laura Grace', EmailId: '[email protected]' },
        { Name: 'Albert', EmailId: '[email protected]' },
        { Name: 'William', EmailId: '[email protected]' },
    ];
    let fieldsData = { text: 'Name' };
    return (<div className='control-pane'>
        <div className='control-section' id="rte">
        <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={rteValue} placeholder="Type @ and tag the name">
            <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
        </div>
        </div>
        <MentionComponent id="mentionEditor" suggestionCount={5} target="#mention_integration_rte-edit-view" dataSource={data} fields={fieldsData}></MentionComponent>
    </div>);
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

function App() {
    let rteValue:string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
 
    let data: { [key: string]: Object }[] = [
      { Name: 'Selma Rose', EmailId: '[email protected]' },
      { Name: 'Maria', EmailId: '[email protected]' },
      { Name: 'Russo Kay', EmailId: '[email protected]' },
      { Name: 'Robert', EmailId: '[email protected]' },
      { Name: 'Camden Kate', EmailId: '[email protected]' },
      { Name: 'Sophia', EmailId: '[email protected]' },
      { Name: 'Margaret', EmailId: '[email protected]' },
      { Name: 'Ursula Ann', EmailId: '[email protected]' },
      { Name: 'Laura Grace', EmailId: '[email protected]' },
      { Name: 'Albert', EmailId: '[email protected]' },
      { Name: 'William', EmailId: '[email protected]' },
    ];
    let  fieldsData: { [key: string]: string }={ text: 'Name' };

    return (
    <div className='control-pane'>
        <div className='control-section' id="rte">
        <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={rteValue} placeholder="Type @ and tag the name">
            <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
        </div>
        </div>
        <MentionComponent id="mentionEditor" suggestionCount={5} target="#mention_integration_rte-edit-view" dataSource={data} fields={fieldsData}></MentionComponent>
    </div>
    );
}

export default App;

Customizing suggestion list using templates

Item template

You can customize how each item appears in the suggestion list using the itemTemplate property. This allows you to display additional details such as email, role, or profile image alongside the mention name.

Display template

Use the displayTemplate property to define how the selected mention appears in the editor content.

For example, by default, the mention chip renders as:

<span contenteditable="false" class="e-mention-chip">@Selma Rose</span>

Using the displayTemplate property, you can customize it to render as a clickable link:

<a href="mailto:[email protected]" title="[email protected]" aria-label="Email Selma Rose">@Selma Rose</a>

This allows you to create more interactive and informative mentions within the editor.

In the following sample, we configured the following properties:

  • itemTemplate - Used to display the customized appearance in suggestion list.
  • displayTemplate - Used to customize how the selected value appears in the editor content.
  • allowSpaces - Allow to continue search action if user enter space after mention character while searching.
  • suggestionCount - The maximum number of items that will be displayed in the suggestion list.

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

class App extends React.Component {
    data = [
        { Name: "Selma Rose", Status: "active", EmployeeImage: "2.png", EmailId: "[email protected]" },
        { Name: "Maria", Status: "active", EmployeeImage: "1.png", EmailId: "[email protected]" },
        { Name: "Russo Kay", Status: "busy", EmployeeImage: "8.png", EmailId: "[email protected]" },
        { Name: "Camden Kate", Status: "active", EmployeeImage: "9.png", EmailId: "[email protected]" },
        { Name: "Robert", Status: "busy", EmployeeImage: "dp.png", EmailId: "[email protected]" },
        { Name: "Garth", Status: "active", EmployeeImage: "7.png", EmailId: "[email protected]" },
        { Name: "Andrew James", Status: "away", EmployeeImage: "pic04.png", EmailId: "[email protected]" },
        { Name: "Olivia", Status: "busy", EmployeeImage: "5.png", EmailId: "[email protected]" },
        { Name: "Sophia", Status: "away", EmployeeImage: "6.png", EmailId: "[email protected]" },
        { Name: "Margaret", Status: "active", EmployeeImage: "3.png", EmailId: "[email protected]" },
        { Name: "Ursula Ann", Status: "active", EmployeeImage: "dp.png", EmailId: "[email protected]" },
        { Name: "Laura Grace", Status: "away", EmployeeImage: "4.png", EmailId: "[email protected]" },
        { Name: "Albert", Status: "active", EmployeeImage: "pic03.png", EmailId: "[email protected]" },
        { Name: "William", Status: "away", EmployeeImage: "8.png", EmailId: "[email protected]" }
    ];
    fieldsData = { text: 'Name' };
    itemTemplate(data) {
        return (<table>
        <tr>
          <td>
            <div id="mention-TemplateList">
              <img className="mentionEmpImage" src={"src/rich-text-editor/images/" + data.EmployeeImage}/>
              <span className={"e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom" + data.Status}></span>
            </div>
            </td>
            <td className="mentionNameList">
              <span className="person">{data.Name}</span>
              <span className="email">{data.EmailId}</span>
            </td>
          </tr>
        </table>);
    }
    displayTemplate(data) {
        return (<React.Fragment>
         <a href={`mailto:${data.EmailId}`} title={data.EmailId}>@{data.Name}</a>
      </React.Fragment>);
    }
    actionBegineHandler(args) {
        if (args.requestType === 'EnterAction') {
            args.cancel = true;
        }
    }
    rteValue = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
    
    render() {
        return (<div className='control-pane'>
        <div className='control-section' id="rte">
          <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={this.rteValue} placeholder="Type @ and tag the name" actionBegin={this.actionBegineHandler.bind(this)}>
              <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
          </div>
        </div>

        <MentionComponent id="mentionEditor" target="#mention_integration_rte-edit-view" suggestionCount={8} showMentionChar={false} allowSpaces={true} dataSource={this.data} fields={this.fieldsData} popupWidth="250px" popupHeight="200px" itemTemplate={this.itemTemplate} displayTemplate={this.displayTemplate}></MentionComponent>
      </div>);
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

class App extends React.Component<{},{}> {
  public mentionObj : MentionComponent;
  private data: { [key: string]: Object }[] = [
    { Name: "Selma Rose", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/2.png", EmailId: "[email protected]" },
    { Name: "Maria", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/1.png", EmailId: "[email protected]" },
    { Name: "Russo Kay", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" },
    { Name: "Camden Kate", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/9.png", EmailId: "[email protected]" },
    { Name: "Robert", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
    { Name: "Garth", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/7.png", EmailId: "[email protected]" },
    { Name: "Andrew James", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic04.png", EmailId: "[email protected]" },
    { Name: "Olivia", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/5.png", EmailId: "[email protected]" },
    { Name: "Sophia", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/6.png", EmailId: "[email protected]" },
    { Name: "Margaret", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/3.png", EmailId: "[email protected]" },
    { Name: "Ursula Ann", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
    { Name: "Laura Grace", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/4.png", EmailId: "[email protected]" },
    { Name: "Albert", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic03.png", EmailId: "[email protected]" },
    { Name: "William", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" }
  ];
  private  fieldsData: { [key: string]: string }={ text: 'Name' };

  private itemTemplate(data: any): JSX.Element {
    return (
      <table>
        <tr>
          <td>
            <div id="mention-TemplateList">
              <img className="mentionEmpImage" src={data.EmployeeImage} />
              <span className={"e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom"+ data.Status}></span>
            </div>
            </td>
            <td className="mentionNameList">
              <span className="person">{data.Name}</span>
              <span className="email">{data.EmailId}</span>
            </td>
          </tr>
        </table>
      );
  }

  private displayTemplate(data: any): JSX.Element {
    return (
      <React.Fragment>
         <a href={`mailto:${data.EmailId}`} title={data.EmailId}>@{data.Name}</a>
      </React.Fragment>
      );
  }
  public actionBegineHandler(args: any): void {
    if (args.requestType === 'EnterAction' && this.mentionObj.element.classList.contains('e-popup-open')) {
      args.cancel = true;
    }
  }
  private rteValue:string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
    
  render() {
    return (
      <div className='control-pane'>
        <div className='control-section' id="rte">
          <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={this.rteValue} placeholder="Type @ and tag the name"  actionBegin={this.actionBegineHandler.bind(this)}  >
              <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]} />
            </RichTextEditorComponent>
          </div>
        </div>

        <MentionComponent ref={(scope) => { this.mentionObj = scope; }} id="mentionEditor" target="#mention_integration_rte-edit-view" suggestionCount={8} showMentionChar={false}  allowSpaces={true} dataSource={this.data} fields={this.fieldsData} popupWidth="250px" popupHeight="200px" itemTemplate={this.itemTemplate} displayTemplate={this.displayTemplate}></MentionComponent>
      </div>
    );
  }
}

export default App;

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

function App() {
    let rteValue = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
   
    let data = [
        { Name: "Selma Rose", Status: "active", EmployeeImage: "2.png", EmailId: "[email protected]" },
        { Name: "Maria", Status: "active", EmployeeImage: "1.png", EmailId: "[email protected]" },
        { Name: "Russo Kay", Status: "busy", EmployeeImage: "8.png", EmailId: "[email protected]" },
        { Name: "Camden Kate", Status: "active", EmployeeImage: "9.png", EmailId: "[email protected]" },
        { Name: "Robert", Status: "busy", EmployeeImage: "dp.png", EmailId: "[email protected]" },
        { Name: "Garth", Status: "active", EmployeeImage: "7.png", EmailId: "[email protected]" },
        { Name: "Andrew James", Status: "away", EmployeeImage: "pic04.png", EmailId: "[email protected]" },
        { Name: "Olivia", Status: "busy", EmployeeImage: "5.png", EmailId: "[email protected]" },
        { Name: "Sophia", Status: "away", EmployeeImage: "6.png", EmailId: "[email protected]" },
        { Name: "Margaret", Status: "active", EmployeeImage: "3.png", EmailId: "[email protected]" },
        { Name: "Ursula Ann", Status: "active", EmployeeImage: "dp.png", EmailId: "[email protected]" },
        { Name: "Laura Grace", Status: "away", EmployeeImage: "4.png", EmailId: "[email protected]" },
        { Name: "Albert", Status: "active", EmployeeImage: "pic03.png", EmailId: "[email protected]" },
        { Name: "William", Status: "away", EmployeeImage: "8.png", EmailId: "[email protected]" }
    ];
    let fieldsData = { text: 'Name' };
    function itemTemplate(data) {
        return (<table>
          <tr>
            <td>
              <div id="mention-TemplateList">
                <img className="mentionEmpImage" src={"src/rich-text-editor/images/" + data.EmployeeImage}/>
                <span className={"e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom" + data.Status}></span>
              </div>
              </td>
              <td className="mentionNameList">
                <span className="person">{data.Name}</span>
                <span className="email">{data.EmailId}</span>
              </td>
            </tr>
          </table>);
    }
    function displayTemplate(data) {
        return (<React.Fragment>
           <a href={`mailto:${data.EmailId}`} title={data.EmailId}>@{data.Name}</a>
        </React.Fragment>);
    }
    function actionBegineHandler(args) {
        if (args.requestType === 'EnterAction') {
            args.cancel = true;
        }
    }
    return (<div className='control-pane'>
        <div className='control-section' id="rte">
        <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={rteValue} placeholder="Type @ and tag the name" actionBegin={actionBegineHandler.bind(this)}>
            <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]}/>
            </RichTextEditorComponent>
        </div>
        </div>
        <MentionComponent id="mentionEditor" target="#mention_integration_rte-edit-view" suggestionCount={8} showMentionChar={false} allowSpaces={true} dataSource={data} fields={fieldsData} popupWidth="250px" popupHeight="200px" itemTemplate={itemTemplate} displayTemplate={displayTemplate}></MentionComponent>
    </div>);
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar } from '@syncfusion/ej2-react-richtexteditor';
import { MentionComponent } from '@syncfusion/ej2-react-dropdowns';
import * as React from 'react';

function App() {
    let rteValue:string = "<p>Hello <span contenteditable=\"false\" class=\"e-mention-chip\"><a href=\"mailto:[email protected]\" title=\"[email protected]\">&#64;Maria</a></span>&#8203;</p><p>Welcome to the mention integration with rich text editor demo. Type <code>&#64;</code> character and tag user from the suggestion list.</p>";
   
    let mentionObj;
    let data: { [key: string]: Object }[] = [
      { Name: "Selma Rose", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/2.png", EmailId: "[email protected]" },
      { Name: "Maria", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/1.png", EmailId: "[email protected]" },
      { Name: "Russo Kay", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" },
      { Name: "Camden Kate", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/9.png", EmailId: "[email protected]" },
      { Name: "Robert", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
      { Name: "Garth", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/7.png", EmailId: "[email protected]" },
      { Name: "Andrew James", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic04.png", EmailId: "[email protected]" },
      { Name: "Olivia", Status: "busy", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/5.png", EmailId: "[email protected]" },
      { Name: "Sophia", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/6.png", EmailId: "[email protected]" },
      { Name: "Margaret", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/3.png", EmailId: "[email protected]" },
      { Name: "Ursula Ann", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/dp.png", EmailId: "[email protected]" },
      { Name: "Laura Grace", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/4.png", EmailId: "[email protected]" },
      { Name: "Albert", Status: "active", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/pic03.png", EmailId: "[email protected]" },
      { Name: "William", Status: "away", EmployeeImage: "https://ej2.syncfusion.com/demos/src/rich-text-editor/images/8.png", EmailId: "[email protected]" }
    ];
    let  fieldsData: { [key: string]: string }={ text: 'Name' };
  
    function itemTemplate(data: any) {
      return (
        <table>
          <tr>
            <td>
              <div id="mention-TemplateList">
                <img className="mentionEmpImage" src={data.EmployeeImage} />
                <span className={"e-badge e-badge-success e-badge-overlap e-badge-dot e-badge-bottom"+ data.Status}></span>
              </div>
              </td>
              <td className="mentionNameList">
                <span className="person">{data.Name}</span>
                <span className="email">{data.EmailId}</span>
              </td>
            </tr>
          </table>
        );
    }

    function displayTemplate(data: any) {
      return (
        <React.Fragment>
           <a href={`mailto:${data.EmailId}`} title={data.EmailId}>@{data.Name}</a>
        </React.Fragment>
        );
    }

    function actionBegineHandler(args: any): void {
      if (args.requestType === 'EnterAction' && mentionObj.element.classList.contains('e-popup-open')) {
        args.cancel = true;
      }
    }
    return (
    <div className='control-pane'>
        <div className='control-section' id="rte">
        <div className='rte-control-section'>
            <RichTextEditorComponent id="mention_integration" value={rteValue} placeholder="Type @ and tag the name"  actionBegin={actionBegineHandler.bind(this)}  >
            <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]} />
            </RichTextEditorComponent>
        </div>
        </div>
        <MentionComponent ref={(scope) => { mentionObj = scope; }} id="mentionEditor" target="#mention_integration_rte-edit-view" suggestionCount={8} showMentionChar={false}  allowSpaces={true} dataSource={data} fields={fieldsData} popupWidth="250px" popupHeight="200px" itemTemplate={itemTemplate} displayTemplate={displayTemplate}></MentionComponent>
    </div>
    );
}

export default App;

View Sample

See also